require 'uu/os/rest/dto'
require 'uu/os/uesuri'


# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Activity Template.
    module ActivityTemplate
      # @see ActivityTemplate#create
      class ActivityTemplateCreate < UU::OS::REST::DTO

        # @see ActivityTemplate#create
        attr_accessor :name

        # @see ActivityTemplate#create
        attr_accessor :code

        # @see ActivityTemplate#create
        attr_accessor :description

        # @see ActivityTemplate#create
        attr_accessor :type

        # @see ActivityTemplate#create
        attr_accessor :related_object_uri

        # @see ActivityTemplate#create
        attr_accessor :icon_uri

        # @see ActivityTemplate#create
        attr_accessor :allow_creation_through_ui

        # @see ActivityTemplate#create
        attr_accessor :notification

        # @see ActivityTemplate#create
        attr_accessor :duration

        # @see ActivityTemplate#create
        attr_accessor :expiration

        # @see ActivityTemplate#create
        attr_accessor :allow_as_subactivity_template

        # @see ActivityTemplate#create
        attr_accessor :default_subactivity_template_uri

        # @see ActivityTemplate#create
        attr_accessor :executive_role_uri

        # @see ActivityTemplate#create
        attr_accessor :block_time_in_calendar

        # @see ActivityTemplate#create
        attr_accessor :allow_executive_role_change

        # @see ActivityTemplate#create
        attr_accessor :allow_subactivities

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def type
          attributes[:type]
        end

        def type=(val)
          attributes[:type] = val
        end

        def related_object_uri
          attributes[:relatedObjectUri]
        end

        def related_object_uri=(val)
          if val
            attributes[:relatedObjectUri] = UU::OS::UESURI.new(val)
          else
            attributes[:relatedObjectUri] = nil
          end
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def allow_creation_through_ui
          attributes[:allowCreationThroughUi]
        end

        def allow_creation_through_ui=(val)
          attributes[:allowCreationThroughUi] = val
        end

        def notification
          attributes[:notification]
        end

        def notification=(val)
          attributes[:notification] = val
        end

        def duration
          attributes[:duration]
        end

        def duration=(val)
          attributes[:duration] = val
        end

        def expiration
          attributes[:expiration]
        end

        def expiration=(val)
          attributes[:expiration] = val
        end

        def allow_as_subactivity_template
          attributes[:allowAsSubactivityTemplate]
        end

        def allow_as_subactivity_template=(val)
          attributes[:allowAsSubactivityTemplate] = val
        end

        def default_subactivity_template_uri
          attributes[:defaultSubactivityTemplateUri]
        end

        def default_subactivity_template_uri=(val)
          if val
            attributes[:defaultSubactivityTemplateUri] = UU::OS::UESURI.new(val)
          else
            attributes[:defaultSubactivityTemplateUri] = nil
          end
        end

        def executive_role_uri
          attributes[:executiveRoleUri]
        end

        def executive_role_uri=(val)
          if val
            attributes[:executiveRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:executiveRoleUri] = nil
          end
        end

        def block_time_in_calendar
          attributes[:blockTimeInCalendar]
        end

        def block_time_in_calendar=(val)
          attributes[:blockTimeInCalendar] = val
        end

        def allow_executive_role_change
          attributes[:allowExecutiveRoleChange]
        end

        def allow_executive_role_change=(val)
          attributes[:allowExecutiveRoleChange] = val
        end

        def allow_subactivities
          attributes[:allowSubactivities]
        end

        def allow_subactivities=(val)
          attributes[:allowSubactivities] = val
        end

      end
    end

  end
end
