require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module Artifact
      # @see Artifact#set_attributes
      class ArtifactSetAttributes < UU::OS::REST::DTO

        # @see Artifact#set_attributes
        attr_accessor :code

        # @see Artifact#set_attributes
        attr_accessor :description

        # @see Artifact#set_attributes
        attr_accessor :icon_uri

        # @see Artifact#set_attributes
        attr_accessor :name

        # @see Artifact#set_attributes
        attr_accessor :security_level
        
        # @see Artifact#set_attributes
        attr_accessor :component_content

        # @deprecated Input value is ignored, nil is always assumed.
        attr_accessor :artifact_type

        # @deprecated
        def artifact_type
          nil
        end

        # @deprecated
        def artifact_type=(val)
        end
        
        def code 
          attributes[:code]
        end

        def code=(val) 
          attributes[:code] = val
        end

        def description 
          attributes[:description]
        end

        def description=(val) 
          attributes[:description] = val
        end

        def icon_uri 
          attributes[:iconUri]
        end

        def icon_uri=(val) 
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def name 
          attributes[:name]
        end

        def name=(val) 
          attributes[:name] = val
        end

        def security_level 
          attributes[:securityLevel]
        end

        def  security_level=(val) 
          attributes[:securityLevel] = val
        end
        
        def component_content
          attributes[:componentContent]
        end
 
        def component_content=(val) 
          attributes[:componentContent] = val
        end
      end
    end
  end
end