require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module Artifact
      class ArtifactSetState < UU::OS::REST::DTO

        # UESURI of the activity template. If it is not specified, either state_template_uri
        # or type is used to determine the new state. Only one of these three parameters
        # can be set to a non-null value.
        #
        # @deprecated This attribute has been replaced by {#state_template_uri} which is more useful.
        attr_accessor :activity_template_uri

        # @see Artifact#set_state
        attr_accessor :state_template_uri

        # @see Artifact#set_state
        attr_accessor :comment

        # @see Artifact#set_state
        attr_accessor :type

        # @deprecated This attribute has been replaced by {#state_template_uri} which is more useful.
        def activity_template_uri
          attributes[:activityTemplateUri]
        end

        # @deprecated This attribute has been replaced by {#state_template_uri=} which is more useful.
        def activity_template_uri=(val) 
          if val
            attributes[:activityTemplateUri] = UU::OS::UESURI.new(val)
          else
            attributes[:activityTemplateUri] = nil
          end
        end

        def state_template_uri
          attributes[:stateTemplateUri]
        end

        def state_template_uri=(val) 
          if val
            attributes[:stateTemplateUri] = UU::OS::UESURI.new(val)
          else
            attributes[:stateTemplateUri] = nil
          end
        end

        def comment 
          attributes[:comment]
        end

        def comment=(val) 
          attributes[:comment] = val
        end

        def type 
          attributes[:type]
        end

        def type=(val) 
          attributes[:type] = val
        end
      end
    end
  end
end
