require 'uu/os/rest/paging_criteria'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Attachment.
    module Attachment
      # @see Attachment#get_version_list
      class AttachmentGetVersionList < UU::OS::REST::PagingCriteria

        # The <b>UES query</b> string. It has to conform the ues query syntax (see documentation for more info). 
        # Filtering and order of the result list can be specified there. When null is set, no filtering is applied and entries are ordered by creationTime.
        attr_accessor :query
        
        def query 
          attributes[:query]
        end

        def query=(val) 
          attributes[:query] = val
        end

      end
    end
  end
end
