require 'delegate'
# @private
# Wrapper for objects(e.g. IO, StreamIO) where we need path method for file name recognition by rest client
module UU
  module OS
    module Attachment
      class StreamWrapper < Delegator
        # Path of the file
        attr_accessor :path

        attr_accessor :original_filename

        def initialize(obj, path)
          super obj              # pass obj to Delegator constructor, required
          @delegate_sd_obj = obj # store obj for future use
          @path = path
          @original_filename = File.basename(path)
        end

        def __getobj__
          @delegate_sd_obj # return object we are delegating to, required
        end

        def __setobj__(obj)
          @delegate_sd_obj = obj # change delegation object,
                                 # a feature we're providing
        end
      end
    end
  end
end