require 'uu/os/rest/dto'
require 'uu/os/uesuri'


module UU
module OS
module Company

# @deprecated
class CompanyAttributes < UU::OS::REST::DTO

# Normalized UESURI of the company. Never null. 
attr_accessor :uri

# Name of the company. Never null. 
attr_accessor :name

# Code of the company. Never null. 
attr_accessor :code

# Description of the company. Never null. 
attr_accessor :description

# URI of the company's container. Returns null if the company is the root of a territory 
# (therefore there is no superior folder, organizational unit etc.). 
attr_accessor :location_uri

# URI of the parent organizational unit. Returns null if the container is the root 
# of a territory (therefore there is no superior container). 
attr_accessor :organizational_unit_uri

# URI of the parent company for specified company. Returns null if the container 
# is the root of a territory (therefore there is no superior territory). 
# @deprecated
attr_accessor :company_uri

# UESURI of the entity type of the company (see {cz.ues.core.sysc.entitytype.UESCoreEntityTypes} 
# for more info). Never null. 
attr_accessor :entity_type_uri

# URI of the meta artifact. Never null. 
attr_accessor :meta_artifact_uri

# URI of the competent role. Never null. 
attr_accessor :competent_role_uri

# Security level of the company. Never null. 
attr_accessor :security_level

# Creation stamp of the company.
attr_accessor :creation_stamp

# Creation time of the company.
attr_accessor :creation_time

# Modification stamp of the company.
attr_accessor :modification_stamp

# Modification time of the company.
attr_accessor :modification_time

# Version of the company.
attr_accessor :version

# URI of the company's icon. When null is set, the company uses icon from meta artifact.
attr_accessor :icon_uri

  # @deprecated Always returns nil.
  attr_accessor :artifact_type

  # @deprecated Always returns nil.
  def artifact_type
    nil
  end

  # @deprecated Input value is ignored, nil is always assumed.
  def artifact_type=(val)
  end

def uri 
attributes[:uri]
end

def uri=(val) 
if val
attributes[:uri] = UU::OS::UESURI.new(val)
else
attributes[:uri] = nil
end
end

def name 
attributes[:name]
end

def name=(val) 
attributes[:name] = val
end

def code 
attributes[:code]
end

def code=(val) 
attributes[:code] = val
end

def description 
attributes[:description]
end

def description=(val) 
attributes[:description] = val
end

def location_uri 
attributes[:locationUri]
end

def location_uri=(val) 
if val
attributes[:locationUri] = UU::OS::UESURI.new(val)
else
attributes[:locationUri] = nil
end
end

def organizational_unit_uri 
attributes[:organizationalUnitUri]
end

def organizational_unit_uri=(val) 
if val
attributes[:organizationalUnitUri] = UU::OS::UESURI.new(val)
else
attributes[:organizationalUnitUri] = nil
end
end

# @deprecated
def company_uri 
attributes[:companyUri]
end

# @deprecated
def company_uri=(val) 
if val
attributes[:companyUri] = UU::OS::UESURI.new(val)
else
attributes[:companyUri] = nil
end
end

def entity_type_uri 
attributes[:entityTypeUri]
end

def entity_type_uri=(val) 
if val
attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
else
attributes[:entityTypeUri] = nil
end
end

def meta_artifact_uri 
attributes[:metaArtifactUri]
end

def meta_artifact_uri=(val) 
if val
attributes[:metaArtifactUri] = UU::OS::UESURI.new(val)
else
attributes[:metaArtifactUri] = nil
end
end

def competent_role_uri 
attributes[:competentRoleUri]
end

def competent_role_uri=(val) 
if val
attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
else
attributes[:competentRoleUri] = nil
end
end

def security_level 
attributes[:securityLevel]
end

def security_level=(val) 
attributes[:securityLevel] = val
end

def creation_stamp 
attributes[:creationStamp]
end

def creation_stamp=(val) 
attributes[:creationStamp] = val
end

def creation_time 
attributes[:creationTime]
end

def creation_time=(val) 
attributes[:creationTime] = val
end

def modification_stamp 
attributes[:modificationStamp]
end

def modification_stamp=(val) 
attributes[:modificationStamp] = val
end

def modification_time 
attributes[:modificationTime]
end

def modification_time=(val) 
attributes[:modificationTime] = val
end

# @deprecated Use {CompanyAttributes#version} instead.
def revision 
attributes[:version]
end

# @deprecated Use {CompanyAttributes#version} instead.
def revision=(val) 
attributes[:version] = val
end

def version 
attributes[:version]
end

def version=(val) 
attributes[:version] = val
end

def icon_uri 
attributes[:iconUri]
end

def icon_uri=(val) 
if val
attributes[:iconUri] = UU::OS::UESURI.new(val)
else
attributes[:iconUri] = nil
end
end

end
end

end

end
