require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module MetaArtifact
      class MetaArtifactSetAttributes < UU::OS::REST::DTO

        # @see MetaArtifact#set_attributes
        attr_accessor :name

        # @see MetaArtifact#set_attributes
        attr_accessor :code

        # @see MetaArtifact#set_attributes
        attr_accessor :description

        # @see MetaArtifact#set_attributes
        attr_accessor :security_level

        # @see MetaArtifact#set_attributes
        attr_accessor :icon_uri

        # @see MetaArtifact#set_attributes
        attr_accessor :default_name

        # @see MetaArtifact#set_attributes
        attr_accessor :default_code

        # @see MetaArtifact#set_attributes
        attr_accessor :default_security_level

        # @see MetaArtifact#set_attributes
        attr_accessor :default_icon_uri

        # @deprecated Input value is ignored, nil is always assumed.
        attr_accessor :default_artifact_type

        # @see MetaArtifact#set_attributes
        attr_accessor :component_content

        # @see MetaArtifact#set_attributes
        attr_accessor :default_component_content
        # @deprecated Always returns nil.
        def default_artifact_type
          nil
        end

        # @deprecated Input value is ignored, nil is always assumed.
        def default_artifact_type=(val)
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def default_name
          attributes[:defaultName]
        end

        def default_name=(val)
          attributes[:defaultName] = val
        end

        def default_code
          attributes[:defaultCode]
        end

        def default_code=(val)
          attributes[:defaultCode] = val
        end

        def default_security_level
          attributes[:defaultSecurityLevel]
        end

        def default_security_level=(val)
          attributes[:defaultSecurityLevel] = val
        end

        def default_icon_uri
          attributes[:defaultIconUri]
        end

        def default_icon_uri=(val)
          if val
            attributes[:defaultIconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:defaultIconUri] = nil
          end
        end

        def component_content
          attributes[:componentContent]
        end

        def component_content=(val)
          attributes[:componentContent] = val
        end

        def default_component_content
          attributes[:defaultComponentContent]
        end

        def default_component_content=(val)
          attributes[:defaultComponentContent] = val
        end

      end
    end

  end
end
