require 'uu/os/rest/paging_criteria'


module UU
module OS
module Property

class PropertyGetPropertyList < UU::OS::REST::PagingCriteria

# Filter for filtering the result according to the property code. When null is set 
# or if <code>codeFilter</code> is an empty string, no filtering according to the 
# code is applied. Filter behavior is similar to the SQL like predicate pattern string. 
# It is a wildcard with these special characters: % (percent sign) allows matching 
# any string of any length (including zero length) _ (underscore) allows matching 
# a single character \ (backslash) is used to escape any of these special characters 
attr_accessor :code_filter

# Filter for filtering the result according to the property name. When null is set 
# or if <code>nameFilter</code> is an empty string, no filtering according to the 
# name is applied. Filter behavior is similar to the SQL like predicate pattern string. 
# It is a wildcard with these special characters: % (percent sign) allows matching 
# any string of any length (including zero length) _ (underscore) allows matching 
# a single character \ (backslash) is used to escape any of these special characters 
attr_accessor :name_filter

# The <b>UES query</b> string. It has to conform the ues query syntax (see documentation 
# for more info). Filtering and order of the result list can be specified there. When 
# null is set, no filtering is applied and entries are ordered by name and code as the 
# second criteria. 
attr_accessor :query



def code_filter 
attributes[:codeFilter]
end

def code_filter=(val) 
attributes[:codeFilter] = val
end

def name_filter 
attributes[:nameFilter]
end

def name_filter=(val) 
attributes[:nameFilter] = val
end

def query 
attributes[:query]
end

def query=(val) 
attributes[:query] = val
end

end

end
end
end
