require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module UseCase
      class UseCaseAttributes < UU::OS::REST::DTO

        # The normalized UESURI of the use case. Never nil.
        attr_accessor :uri

        # The name of the use case. Never nil.
        attr_accessor :name

        # The code of the use case. Never nil.
        attr_accessor :code

        # The description of the use case. Never nil.
        attr_accessor :description

        # The UESURI of a use case realization.
        attr_accessor :use_case_realization_uri
        
        # The type of the use case.
        attr_accessor :use_case_type

        # The creation time of the use case. Never nil.
        attr_accessor :creation_time

        # The creation stamp of the use case. Never nil.
        attr_accessor :creation_stamp

        # The modification time of the use case. Never nil.
        attr_accessor :modification_time

        # The modification stamp of the use case. Never nil.
        attr_accessor :modification_stamp

        # The version of the use case. Never nil.
        attr_accessor :version
        
        # UESURI of the entity type of the use case. Never nil.
        attr_accessor :entity_type_uri
                
        def uri 
          attributes[:uri]
        end

        def uri=(val) 
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name 
          attributes[:name]
        end

        def name=(val) 
          attributes[:name] = val
        end

        def code 
          attributes[:code]
        end

        def code=(val) 
          attributes[:code] = val
        end

        def description 
          attributes[:description]
        end

        def description=(val) 
          attributes[:description] = val
        end

        def use_case_realization_uri 
          attributes[:useCaseRealizationUri]
        end

        def use_case_realization_uri=(val) 
          if val
            attributes[:useCaseRealizationUri] = UU::OS::UESURI.new(val)
          else
            attributes[:useCaseRealizationUri] = nil
          end
        end
        
        def use_case_type 
           attributes[:useCaseType]
        end
        
        def use_case_type=(val) 
           attributes[:useCaseType] = val
        end

        def creation_time 
          attributes[:creationTime]
        end

        def creation_time=(val) 
          attributes[:creationTime] = val
        end

        def creation_stamp 
          attributes[:creationStamp]
        end

        def creation_stamp=(val) 
          attributes[:creationStamp] = val
        end

        def modification_time 
          attributes[:modificationTime]
        end

        def modification_time=(val) 
          attributes[:modificationTime] = val
        end

        def modification_stamp 
          attributes[:modificationStamp]
        end

        def modification_stamp=(val) 
          attributes[:modificationStamp] = val
        end

        # @deprecated Use {UseCaseAttributes#version} instead.
        def revision 
          attributes[:version]
        end

        # @deprecated Use {UseCaseAttributes#version} instead.
        def revision=(val) 
          attributes[:version] = val
        end

        def version 
          attributes[:version]
        end

        def version=(val) 
          attributes[:version] = val
        end

        def entity_type_uri 
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val) 
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end
    end

  end
end
